<template>
    <form-wizard
        shape="tab"
        color="#194325"
        :title="field.title"
        :subtitle="field.subtitle"
        @on-error="handleErrorMessage"
    >
        <tab-content
            :title="field.tab2 ? field.tab2.title : ''"
            icon="zmdi zmdi-home"
            :before-change="postAgency"
            lazy="true"
        >
            <div class="content">
                <div class="row">
                    <div class="col-md-10 mx-auto pt-4">
                        <div class="card pt-4">
                            <h3 class="text-center">
                                {{ field.tab2 ? field.tab2.subtitle : "" }}
                            </h3>
                            <div class="row pt-4">
                                <div class="col-md-5 align-self-center">
                                    <vue-dropzone
                                        ref="VueDropzoneAgency"
                                        id="dropzoneAgency"
                                        :options="dropzoneOptions"
                                        :useCustomSlot="true"
                                        v-on:vdropzone-success="logoCharged"
                                    >
                                        <div class="dropzone-custom-content">
                                            <h3 class="text-primary">
                                                <i
                                                    class="zmdi zmdi-cloud-upload"
                                                    style="font-size:32px"
                                                ></i>
                                            </h3>
                                            <h4 class="text-center">
                                                {{
                                                    field.dropzone
                                                        ? field.dropzone.title
                                                        : "Drag and drop to upload content!"
                                                }}
                                            </h4>
                                            <div class="text-center">
                                                {{
                                                    field.dropzone
                                                        ? field.dropzone
                                                              .subtitle
                                                        : "...or click to select a file from your computer"
                                                }}
                                            </div>
                                        </div>
                                    </vue-dropzone>
                                </div>
                                <div class="col-md-7 align-self-center">
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            class="form-control"
                                            :placeholder="
                                                field.tab2
                                                    ? field.tab2.name
                                                    : ''
                                            "
                                            v-model="agency.nombre"
                                        />
                                        <div
                                            class="text-danger"
                                            v-if="!$v.agency.nombre.required"
                                        >
                                            {{
                                                field.messages
                                                    ? field.messages.required
                                                    : "Required"
                                            }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </tab-content>
        <tab-content
            :title="field.tab4 ? field.tab4.title : ''"
            icon="zmdi zmdi-check"
            lazy="true"
        >
            <div class="row">
                <div class="col-8 mx-auto mt-4">
                    <h1 class="text-center">
                        <span class="text-success">
                            <i
                                style="font-size:2cm"
                                class="zmdi zmdi-check-circle"
                            ></i>
                        </span>
                    </h1>
                    <br />
                    <h4 class="mt-0 text-center">
                        {{ field.tab4 ? field.tab4.msg1 : "created" }}
                    </h4>
                    <a
                        :href="'/dashboard/aseguradora'"
                        class="btn btn-block btn-secundary"
                    >
                        {{
                            field.tab4
                                ? field.tab4.see_agency
                                : "see_aseguradora"
                        }}
                    </a>
                </div>
            </div>
        </tab-content>
        <template slot="footer" slot-scope="props">
            <div class="wizard-footer-right">
                <wizard-button
                    v-if="!props.isLastStep"
                    @click.native="props.nextTab()"
                    id="nextButton"
                    class="wizard-footer-right"
                    :style="props.fillButtonStyle"
                    >{{
                        field.button ? field.button.next : "next"
                    }}</wizard-button
                >
            </div>
        </template>
        <div class="alert alert-danger" v-if="errorMsg">
            <span class="text-center"
                ><strong>Oh no! </strong>{{ errorMsg }}</span
            >
        </div>
    </form-wizard>
</template>
<script>
import vue2Dropzone from "vue2-dropzone";
import "vue2-dropzone/dist/vue2Dropzone.min.css";
import { required, minLength, between, email } from "vuelidate/lib/validators";
import VuePhoneNumberInput from "vue-phone-number-input";
import "vue-phone-number-input/dist/vue-phone-number-input.css";
import VueGoogleAutocomplete from "vue-google-autocomplete";
export default {
    props: ["lang"],
    components: {
        vueDropzone: vue2Dropzone,
        VuePhoneNumberInput: VuePhoneNumberInput,
        VueGoogleAutocomplete
    },
    mounted() {
        console.log(this.field);
    },
    data() {
        return {
            field: this.lang,
            loadingWizard: false,
            errorMsg: null,
            tab1: null,
            search: null,
            address: null,
            phone: [],
            assigned: [],
            agency: {
                nombre: ""
            },
            dropzoneOptions: {
                url: "/api/files/stored",
                addRemoveLinks: true,
                thumbnailWidth: 150,
                maxFilesize: 0.5,
                acceptedFiles: "image/*",
                capture: true,
                uploadMultiple: false,
                maxFiles: 1,
                headers: {
                    Authorization:
                        "Bearer " +
                        decodeURIComponent(localStorage.getItem("req_token"))
                }
            },
            memberships: null
        };
    },
    validations: {
        agency: {
            nombre: {
                required
            }
        }
    },
    methods: {
        postAgency() {
            $("#nextButton").attr("disabled", true);
            return new Promise((next, stop) => {
                axios
                    .post("/api/aseguradora/data", this.agency)
                    .then(res => {
                        this.agency = res.data;
                        $("#nextButton").attr("disabled", false);
                        next(true);
                    })
                    .catch(err => {
                        $("#nextButton").attr("disabled", false);
                        stop(err.response.data.msg);
                        return false;
                    });
            });
        },
        fileCharged(file, res) {
            this.user.feature_image = res;
        },
        logoCharged(file, res) {
            this.agency.logo = res;
        },
        handleErrorMessage: function(errorMsg) {
            this.errorMsg = errorMsg;
        }
    }
};
</script>
